﻿using UnityEngine;
using System.Collections;

public class Attack : MonoBehaviour {

	public GameObject enemy;
	public Transform bulletPos;
	public GameObject[] bullets;
	public float accuracy = 2.0f;
	bool shooting = false;

	void Start () {
	
		for(int i = 0; i < bullets.Length; i++)
		{
			bullets[i].transform.position = bulletPos.position;
			bullets[i].GetComponent<hitDeactivate>().startPos = bulletPos.position;
			bullets[i].SetActive(false);
		}

	}

	void Shoot()
	{
		for(int i = 0; i < bullets.Length; i++)
		{
			if(!bullets[i].active)
			{
				bullets[i].SetActive(true);
				bullets[i].rigidbody.AddForce(this.transform.forward * 300);
				i = bullets.Length + 1;
			}
		}
	}
	
	void Update () {
		transform.rotation = Quaternion.Slerp( this.transform.rotation, 
			Quaternion.LookRotation( enemy.transform.position - transform.position ), 
			Time.deltaTime );

		if(Quaternion.Angle(transform.rotation, 
			Quaternion.LookRotation( 
				enemy.transform.position - transform.position )) <= accuracy && !shooting)
		{
			InvokeRepeating("Shoot",0f,0.5f);
			shooting = true;
		}
		else if(Quaternion.Angle(transform.rotation, 
			Quaternion.LookRotation( 
				enemy.transform.position - transform.position )) > accuracy)
		{
			shooting = false;
			CancelInvoke();
		}
	}
}
